aboutsummaryrefslogtreecommitdiffhomepage
path: root/src/package-bazel.sh
diff options
context:
space:
mode:
authorGravatar Lukacs Berki <lberki@google.com>2015-10-15 12:06:12 +0000
committerGravatar Lukacs Berki <lberki@google.com>2015-10-15 12:28:54 +0000
commit97eaf9136abad30827cf1a060cc32e786745923d (patch)
treee7ddcef93712bf8cc0cb4031a5916d201ae548a3 /src/package-bazel.sh
parent3bb1990892d1bfb5a4e793431cb4730a3c0a06e6 (diff)
Add a //src:bazel-notools target that is the same as the Bazel binary except without the embedded tools.
Its use requires the addition of a local_workspace(name = "bazel_tools", path=...) to the WORKSPACE file. It is useful if you don't care about the set of embedded tools (because you provide them to Bazel in another way anyway) but you do care about the size of the Bazel binary (it's 16 MB compared to 56 MB with the tools). -- MOS_MIGRATED_REVID=105499508
Diffstat (limited to 'src/package-bazel.sh')
-rwxr-xr-xsrc/package-bazel.sh45
1 files changed, 45 insertions, 0 deletions
diff --git a/src/package-bazel.sh b/src/package-bazel.sh
new file mode 100755
index 0000000000..9181d812d2
--- /dev/null
+++ b/src/package-bazel.sh
@@ -0,0 +1,45 @@
+#!/bin/bash -eu
+#
+# Copyright 2015 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# This script bootstraps building a Bazel binary without Bazel then
+# use this compiled Bazel to bootstrap Bazel itself. It can also
+# be provided with a previous version of Bazel to bootstrap Bazel
+# itself.
+
+WORKDIR=$(pwd)
+OUT=$1
+EMBEDDED_TOOLS=$2
+DEPLOY_JAR=$3
+INSTALL_BASE_KEY=$4
+shift 4
+
+TMP_DIR=${TMPDIR:-/tmp}
+PACKAGE_DIR="$(mktemp -d ${TMP_DIR%%/}/bazel.XXXXXXXX)"
+mkdir -p "${PACKAGE_DIR}"
+trap "rm -fr ${PACKAGE_DIR}" EXIT
+
+cp $* ${PACKAGE_DIR}
+cp ${DEPLOY_JAR} ${PACKAGE_DIR}/A-server.jar
+cp ${INSTALL_BASE_KEY} ${PACKAGE_DIR}/install_base_key
+# The timestamp of embedded tools should already be zeroed out in the input zip
+touch -t 198001010000.00 ${PACKAGE_DIR}/*
+
+if [[ ${EMBEDDED_TOOLS} != "" ]]; then
+ mkdir ${PACKAGE_DIR}/embedded_tools
+ (cd ${PACKAGE_DIR}/embedded_tools && unzip -q ${WORKDIR}/${EMBEDDED_TOOLS})
+fi
+
+(cd ${PACKAGE_DIR}; zip -qrD ${WORKDIR}/${OUT} *)